package com.example.utils;

import java.util.concurrent.atomic.AtomicInteger;

import com.machinezoo.sourceafis.FingerprintImage;
import com.machinezoo.sourceafis.FingerprintTemplate;

public class CheckEdgeScore {
    // Static helper method to use this class easily
    
    public static AtomicInteger calculateEdgeScore(byte[] imageBytes) {
        try (TransparencyContents transparency = new TransparencyContents()) {
            AtomicInteger edgeScore = new AtomicInteger();
            FingerprintTemplate probe = new FingerprintTemplate(new FingerprintImage(imageBytes));
            transparency.accepts("edge-table");
            transparency.take("edge-table", "application/cbor", imageBytes);
            edgeScore.set(transparency.countEdgeNumber());
            System.out.println("EdgeScore: " + edgeScore);
            return edgeScore;
        } catch (Exception e) {
            System.out.println("Error calculating edge score: " + e.getMessage());
            return null;
        }
    }
}
